﻿Module ioControl
    Dim serport As New System.IO.Ports.SerialPort
    Public Function openPort(ByVal PortNumber As Integer) As Boolean
        If (PortNumber) And Not serport.IsOpen Then
            serport.PortName = "COM" + Trim(Str(PortNumber))
            serport.Open()
            serport.DiscardInBuffer()
            serport.DiscardOutBuffer()
            Return True
        Else
            Return False
        End If
    End Function
    Public Sub closePort()
        If (serport.IsOpen) Then
            serport.Close()
        End If
    End Sub
    Public Function sendData(ByVal data As String) As Boolean
        If serport.IsOpen Then
            serport.DiscardOutBuffer()
            serport.Write(data)
            Return True
        Else
            Return False
        End If
    End Function

    Public Function receiveData() As String
        If serport.IsOpen Then
            Return serport.ReadExisting
            Return True
        Else
            Return ""
        End If
    End Function

    Public Function inputCount() As Integer
        Return serport.BytesToRead
    End Function

    Public Function relayOn(ByVal RelayNum As Integer) As Boolean
        Return sendData("relay on" + Str(RelayNum) + Chr(13))
    End Function
    Public Function relayOff(ByVal RelayNum As Integer) As Boolean
        Return sendData("relay off" + Str(RelayNum) + Chr(13))
    End Function

    Public Function getrelayStatus(ByVal RelayNum As Integer) As String

        Dim tmpStr As String

        sendData("relay read" + Str(RelayNum) + Chr(13))

        System.Threading.Thread.Sleep(10)

        'read
        tmpStr = receiveData()

        If (InStr(tmpStr, "on")) Then
            Return "on"
        End If

        If (InStr(tmpStr, "off")) Then
            Return "off"
        End If

        Return ""

    End Function



    Public Function setGPIO(ByVal GpioNum As Integer) As Boolean
        Return sendData("gpio set" + Str(GpioNum) + Chr(13))
    End Function
    Public Function clearGPIO(ByVal GpioNum As Integer) As Boolean
        Return sendData("gpio clear" + Str(GpioNum) + Chr(13))
    End Function

    Public Function getGpioStatus(ByVal gpioNum As Integer) As String

        Dim tmpStr As String

        sendData("gpio read" + Str(gpioNum) + Chr(13))

        System.Threading.Thread.Sleep(10)

        'read
        tmpStr = receiveData()

        tmpStr = Mid(tmpStr, 14, 1)

        If (InStr(tmpStr, "1")) Then
            Return "on"
        End If

        If (InStr(tmpStr, "0")) Then
            Return "off"
        End If

        Return ""

    End Function

    Public Function getAdcValue(ByVal gpioNum As Integer) As String

        Dim tmpStr As String
        Dim i
        Dim count = 0

        sendData("adc read" + Str(gpioNum) + Chr(13))

        System.Threading.Thread.Sleep(10)

        'read
        tmpStr = receiveData()

        tmpStr = Mid(tmpStr, 13, 4)

        For i = 1 To Len(tmpStr)
            If (IsNumeric(Mid(tmpStr, i, 1))) Then
                count = count + 1
            Else
                Exit For
            End If
        Next


        Return Mid(tmpStr, 1, count)

    End Function
End Module
